package be.iminds.ilabt.jfed.rspec.parser.extensions;

import be.iminds.ilabt.jfed.lowlevel.api.user_spec.UserSpec;
import be.iminds.ilabt.jfed.rspec.model.bonfire.DiskImage;
import be.iminds.ilabt.jfed.rspec.model.bonfire.Lan;
import be.iminds.ilabt.jfed.rspec.parser.ExtraXml;
import javanet.staxutils.IndentingXMLEventWriter;

import javax.xml.stream.XMLEventFactory;
import javax.xml.stream.XMLEventWriter;
import javax.xml.stream.XMLOutputFactory;
import javax.xml.stream.XMLStreamException;
import java.io.StringWriter;
import java.util.List;
import java.util.concurrent.Callable;

import static be.iminds.ilabt.jfed.rspec.parser.RspecXmlConstants.*;

/**
 * User: twalcari
 * Date: 3/9/2015
 * Time: 15:00
 */
public class BonfireWriter {
    private BonfireWriter() {
    }

    public static void write(XMLEventFactory eventFactory, XMLEventWriter eventWriter, Lan lan) throws XMLStreamException {
        eventWriter.add(eventFactory.createStartElement(Q_BONFIRE_LAN, null, null));

        if (lan.getComponentManagerId() != null)
            eventWriter.add(eventFactory.createAttribute(Q_ATT_COM_MAN_ID, lan.getComponentManagerId()));
        if (lan.getComponentId() != null)
            eventWriter.add(eventFactory.createAttribute(Q_ATT_COM_ID, lan.getComponentId()));
        if (lan.getComponentName() != null)
            eventWriter.add(eventFactory.createAttribute(Q_ATT_COM_NAME, lan.getComponentName()));
        if (lan.getExclusive() != null)
            eventWriter.add(eventFactory.createAttribute(Q_ATT_NODE_EXCLUSIVE, lan.getExclusive() ? "true" : "false"));

        for (ExtraXml extra : lan.getExtraXmls())
            extra.writeEvents(eventWriter);

        eventWriter.add(eventFactory.createEndElement(Q_BONFIRE_LAN, null));
    }
    public static void write(XMLEventFactory eventFactory, XMLEventWriter eventWriter, DiskImage diskImage) throws XMLStreamException {
        eventWriter.add(eventFactory.createStartElement(Q_BONFIRE_DISK_IMAGE, null, null));

        if (diskImage.getComponentManagerId() != null)
            eventWriter.add(eventFactory.createAttribute(Q_ATT_COM_MAN_ID, diskImage.getComponentManagerId()));
        if (diskImage.getComponentId() != null)
            eventWriter.add(eventFactory.createAttribute(Q_ATT_COM_ID, diskImage.getComponentId()));
        if (diskImage.getComponentName() != null)
            eventWriter.add(eventFactory.createAttribute(Q_ATT_COM_NAME, diskImage.getComponentName()));
        if (diskImage.getExclusive() != null)
            eventWriter.add(eventFactory.createAttribute(Q_ATT_NODE_EXCLUSIVE, diskImage.getExclusive() ? "true" : "false"));

        if (diskImage.getOcciType() != null) {
            eventWriter.add(eventFactory.createStartElement(Q_OCCI_TYPE, null, null));
            eventWriter.add(eventFactory.createCharacters(diskImage.getOcciType()));
            eventWriter.add(eventFactory.createEndElement(Q_OCCI_TYPE, null));
        }

        if (diskImage.getOcciDescription() != null) {
            eventWriter.add(eventFactory.createStartElement(Q_OCCI_DESCRIPTION, null, null));
            eventWriter.add(eventFactory.createCharacters(diskImage.getOcciDescription()));
            eventWriter.add(eventFactory.createEndElement(Q_OCCI_DESCRIPTION, null));
        }

        for (ExtraXml extra : diskImage.getExtraXmls())
            extra.writeEvents(eventWriter);

        eventWriter.add(eventFactory.createEndElement(Q_BONFIRE_DISK_IMAGE, null));
    }

}
